# UDP listener optimized for Counter-Strike: 2D logging.
# Created by Banaan - www.servers.cs2d.nl - servers@cs2d.nl

import SocketServer, sys, os, string, re, urllib2
from time import strftime

VERSION = "0.1"
iplist = [ "http://cs2d.nl/whatismyip.php", "http://whatismyip.akamai.com/", "http://whatismyip.org/" ]

class MyUDPHandler(SocketServer.BaseRequestHandler):

	def handle(self):
		data = self.request[0].strip()
		path = self.client_address[0] + "-" + str(self.client_address[1])
		f = path + "/" + strftime("%d-%b-%Y") + ".txt"
		if len(data)<10 and not os.path.isdir(path):
			pass
		else:
			if not os.path.isdir(path):
				os.mkdir(path)
			if not os.path.isfile(f):
				os.open(f,os.O_CREAT | os.O_APPEND)
				l = open(f,"a")
				l.write("#############################################################\n")
				l.write("#  Welcome to CS2DLogger, the CS2D-optimized UDP listener   #\n")
				l.write("# Created by Banaan - www.servers.cs2d.nl - servers@cs2d.nl #\n")
				l.write("#         For help and info, type cs2dlogger --help         #\n")
				l.write("#############################################################\n\n")
				l.close()
			l = open(f,"a")
			data = data[5:].strip()
			data = re.sub("[\xF3].[\x00]","\n",data)
			data = data.split("\n")
			for x in data:
				l.write(strftime("[%H:%M:%S] ") + x + "\n")
			l.close()

if __name__ == "__main__":
	print '''
#############################################################
#  Welcome to CS2DLogger, the CS2D-optimized UDP listener   #
# Created by Banaan - www.servers.cs2d.nl - servers@cs2d.nl #
#         For help and info, type cs2dlogger --help         #
#############################################################
'''
	for url in iplist:
		try:
			HOST, PORT = urllib2.urlopen(url).read(), 36990
			break
		except:
			pass

	if "--help" in sys.argv:
		print '''CS2DLogger is a simple tool which listens to CS2D server output.
It is created to simplify the use of extra logaddresses in CS2D.


// Usage:

CS2DLogger is a UDP listener, which stores the output of CS2D.
It can be used for both CS2D servers and clients, that is, both
server output and client output can be sent.
In either case, use the [logaddress_add] command to add the IP
and the port of CS2DLogger, e.g. [logaddress_add ''' + HOST + ":" + str(PORT) + ''']
CS2DLogger will then write the server output into files named
by date, ordered in folders with the CS2D IP and port.

Since each IP:port combination is written into a different folder,
it is no problem whatsoever to use one CS2DLogger server for multiple clients.
Too many clients at once, however, might result in connection
problems or other trouble.


// Command line parameters:

  --help:          Shows this help text,
  --version:       Shows your current CS2DLogger version,
  --ip:            Shows CS2DLogger's IP address

  -port [number]:  Specify a special port for CS2DLogger to use. If no port is
                   specified, the port will default to ''' + str(PORT) + '''.
                   If this port is already in use, CS2DLogger will quit.


// Questions, bug reports and suggestions can be sent to [servers@cs2d.nl]
or reported at [www.cs2d.nl]
'''
		sys.exit()
	elif "--version" in sys.argv:
		print "Your CS2DLogger version is " + VERSION
		sys.exit()
	elif "--ip" in sys.argv:
		print "CS2DLogger's IP address is " + HOST
		sys.exit()
	else:
		if "-port" in sys.argv:
			if len(sys.argv) > sys.argv.index("-port")+1:
				PORT = int(sys.argv[sys.argv.index("-port")+1])
		try:
			server = SocketServer.UDPServer((HOST, PORT), MyUDPHandler)
		except Exception, e:
			try:
				errno, strerror = e
				if errno == 10048:
					print strftime("[%H:%M:%S] ") + "UDP socket could not be initialized."
					print strftime("[%H:%M:%S] ") + "Port " + str(PORT) + " is already in use."
					sys.exit()
				elif errno == 10049:
					print strftime("[%H:%M:%S] ") + "UDP socket cannot bind to your external IP address."
					print strftime("[%H:%M:%S] ") + "Make sure your firewall does not block CS2Dlogger."
					sys.exit()
				elif errno == 10054:
					print strftime("[%H:%M:%S] ") + "Connection failed."
					print strftime("[%H:%M:%S] ") + "External host terminated the connection."
					sys.exit()
				else:
					print strftime("[%H:%M:%S] ") + "An unexpected error occured."
					print strftime("[%H:%M:%S] ") + "UDP socket could not be initialized."
					print strftime("[%H:%M:%S] ") + "Error number " + str(errno) + ": " + strerror
					sys.exit()
			except:
				print "An unexpected error occured!"
				sys.exit()
		else:
			print strftime("[%H:%M:%S] ") + "UDP socket initialized using IP address " + HOST + " and port " + str(PORT)
			server.serve_forever()
